#declare rand_sapin =  seed(458);//seed(9485);//seed(98);// seed(9435);//  
//9435 is not bad, but gives no proper tree top 
//458 is good      
//98 is not terribly good
// ----------------------------------------    
#declare leaf1 = union
{
  cylinder {<0,0,0> <0,1,0> 1
            scale <0.0636,.75,0.0636>                 
           }
  cylinder {<0,0,0> <0,1,0> 1
            scale <0.0636,.75,0.0636> 
            rotate x*90                
           }       
  cylinder {<0,0,0> <0,1,0> 1
            scale <0.0636,.75,0.0636>  
            rotate x*180                
           }      
 /* cylinder {<0,0,0> <0,1,0> 1
            scale <0.0636,.75,0.0636>  
            rotate x*270               
           }        */
  pigment { rgb < 0.3, 0.7745, 0.4 >*.215 }
  //pigment { rgb < 0.349, 0.7745, 0.3667 >*.15 }
} 




#macro place_leaf1(v0, vtrans, gama, leaf_len)   
  #local v4 = vaxis_rotate(vnormalize(<-v0.y, v0.x, 0.000>), v0, gama);
  #local v2 = vaxis_rotate(vnormalize(<-v0.y, v0.x, 0.000>), v0, gama);
  #local v3 = vaxis_rotate(v2, v0, 90);    
  #local v1 = vaxis_rotate(v4, v3, 15-rand(rand_sapin)*30);
  #local alfa = degrees(atan2(v1.z,v1.x));     
  #local v1x = sqrt(v1.x*v1.x+v1.z*v1.z);
  #local beta = degrees(atan2(v1x,v1.y));  

  object {leaf1 scale <1,leaf_len,1>     
          rotate z*-beta
          rotate y*-alfa 
          translate vtrans
         }                          
#end  

//:::::::::::::::::::::::::::::::::::::::::

//sphere {<-8,40,0> 0.5 pigment {color Red}}       
//sphere {<-8,0,0> 0.5 pigment {color Red}}       
//sphere {<-8,-12,0> 0.5 pigment {color Red}}       
       
#declare twig_tex = texture
{
  pigment {color rgb < 0.6, 0.3, 0.15>*.525}   
  normal {                                              
    gradient x       // this is the PATTERN_TYPE
    slope_map {       // Now let's get fancy
      [0.0  <0, 1>]   // Do tiny triangle here
      [0.2  <1, 1>]   //  down
      [0.2  <1,-1>]   //     to
      [0.4  <0,-1>]   //       here.
      [0.4  <0, 0>]   // Flat area
      [0.5  <0, 0>]   //   through here.
      [0.5  <1, 0>]   // Square wave leading edge
      [0.6  <1, 0>]   //   trailing edge
      [0.6  <0, 0>]   // Flat again
      [0.7  <0, 0>]   //   through here.
      [0.7  <0, 3>]   // Start scallop
      [0.8  <1, 0>]   //   flat on top
      [0.9  <0,-3>]   //     finish here.
      [0.9  <0, 0>]   // Flat remaining through 1.0
    }
   turbulence 0.36  
   octaves 2  
   lambda 5  
   omega 0.15  
  }
  scale 0.25  
}





//=========================================================================

#macro twig(vc0, vc1, circumf, sinuosity, leng, blevel, leaf_scaling, rot_angle)
 
   #if (blevel=0) #local thi=circumf*.8; #else #local thi=circumf*1.6; #end
   cylinder {vc0, vc1, thi}  


   
   #local leaf_scaling1=1;  
   #local v1=vc1 - vc0;    
   #local ra=rot_angle; 
      
      #switch (blevel)
        #case (0)  
          #local b_min_angle = 72;
          #local b_max_angle = 75;
          #local leng1=leng*0.998;  
          #local rd1 = circumf*0.97; 
          #local min_circ = 0.25;   
          #if (vc1.y > 38.5) #local rd1 = min_circ*0.75; #end
          #local sinuos = 0.25;
          #local init_angle = rand(rand_sapin)*360;            
        #break
        
        
        #range (1,2) 
          #local b_min_angle = 22;
          #local b_max_angle = 35;
          #local leng1=leng*0.935;  
          #local rd1 = circumf*0.95; 
          #local min_circ = 0.025 + rand(rand_sapin)*0.015; 
          //#if (vc1.y < 1) #local min_circ = 0.05; #end          
          #if (blevel=1) #local sinuos = 6; #else #local sinuos = 1; #end   
          #if (leaf_scaling1 < 0.35) 
            #local leaf_scaling1 = 0.35; 
          #else 
            #local leaf_scaling1=leaf_scaling*0.95;//*(1+0.10*rand(rand_sapin));  
          #end
          #local dv=0.1*vnormalize(v1);  
          #local ldv = vlength(dv); 
          #local lv1 = vlength(v1);
          #local i=1;    
          #while (i*ldv < lv1)
            //#local ra=ra+4;
            //#if (ra>360) #local ra=0; #end
            //place_leaf1(i*dv, vc1+i*dv, rand(rand_sapin)*30+init_angle+ra, leaf_scaling)       
            place_leaf1(i*dv, vc1+i*dv, rand(rand_sapin)*360, leaf_scaling)       
            #local i=i+1;
          #end       
        #break    
        
      #end    
    
    
   #local rc = vlength(v1)*tan(radians(sinuosity));
   #local v2 = vnormalize(<-v1.y, v1.x, 0.1>)*rc*(rand(rand_sapin));
   #local v3 = vnormalize(vaxis_rotate(v2+v1,v1,rand(rand_sapin)*360))*leng;
   
    
   #if (rd1>min_circ & blevel < 3)  
      #local vc2 = v3+vc1;      
      twig(vc1, vc2, rd1, sinuos, leng1, blevel, leaf_scaling1, ra)
           
      #if (b_min_angle = 90) b_min_angle=89;  #end  
      #if (b_max_angle = 90) b_max_angle=91;  #end  

       
      #switch (blevel)
        #case (0)  
          #local rd2 = rd1*0.15;             
          #if (vc1.y > -15)   
             #local new_branch=1;    
          #else
             #local new_branch=0; 
          #end
          #local len_ratio = rd1*1; 
          #local nbr = 3;  
        #break
        
        #case (1)   
          #local rd2 = rd1*0.95;        
          #if (rand(rand_sapin)>0.80) 
           #local new_branch=1;     
          #else
           #local new_branch = 0;  
          #end
          #local len_ratio = rd1*4;  
          #local nbr = 2;  
        #break 
        
        #case (2)   
          #local rd2 = rd1*0.90;
          #if (rand(rand_sapin)>0.80)
           #local new_branch=1; 
          #else
           #local new_branch = 0;   
          #end
          #local len_ratio = rd1*1.5;  
          #local nbr = 1;   
       #break 

        #else
          #local new_branch = 0;
      #end 
                       
                       
       #if (new_branch) 
        #local blevel1=blevel+1;   
        #local rc2 = vlength(v1)*tan(radians(b_max_angle-90)); 
        #local cc = (b_min_angle-90)/(b_max_angle-90);  
        #local bb = 1 / (1 - cc);  
        #local aa = cc*bb;
        #local v4 = vnormalize(<-v1.y, v1.x, 0.000>);  
        #local v6 = vnormalize(<-v4.y, v4.x, 0.000>)*rc2*((rand(rand_sapin)+aa)/bb);  
        #local v5 = (v6+v4); 
        
        #local counter = 0;      
        #while (counter < nbr) 
        #if (blevel=1 & counter=1) 
          #local alfa2 = -init_angle+180; 
        #else  
          #local alfa2 = rand(rand_sapin)*360; 
        #end
        #local init_angle = -alfa2;
        #local v8 = vnormalize(vaxis_rotate(v5,v1,alfa2))*len_ratio + vc1 ; 
       
          twig(vc1+rand(rand_sapin)*0.1*v1, v8, rd2, sinuos, len_ratio,blevel1,leaf_scaling,ra) 
        #local counter = counter+1;
        #end    
       #end    
   #end     
#end


//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                             
#declare vq1=<0, 0, 0>;
#declare vq2=<0, 8, 0>;
#declare tree = union {twig(vq1, vq2, 1, 3, 1., 0, .8, 1)}
    
object
{ 
   tree        
   texture {twig_tex rotate y*80} 
   rotate y*25
   scale <.42/3.3, .42/3.3, .42/3.3>
   translate <-8.5,-.65,2.8>
}   

 
           

                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       
                                                       